
%imNum='00066';
IR=im2double(imread(['/Users/gregorysearch/Desktop/Documents/Masters/3. EE367',...
    '/Final Project/pictures/keepers/IR2.bmp']));
RGB=im2double(imread(['/Users/gregorysearch/Desktop/Documents/Masters/3. EE367',...
    '/Final Project/pictures/keepers/RGB2.bmp']));

%%% Level 1
tic

Level1=0.5*(IR+RGB);

Level1_time=toc;

%%% Level 2
tic
RGBconv=rgb2ycbcr(RGB);

RGBnew(:,:,1)=IR(:,:,1);
RGBnew(:,:,2)=RGBconv(:,:,2);
RGBnew(:,:,3)=RGBconv(:,:,3);

RGBresult=ycbcr2rgb(RGBnew);
Level2_time=toc;


%%% Level 3 
tic
sigma_s=2; %smoothing sigma 
layers=5;
IR=1-IR;
IR=IR(:,:,1);

IRstack=zeros(size(IR,1),size(IR,2),layers); %fourth dim is detail layer #, j
IRstack(:,:,1)=IR;
IRdetail=zeros(size(IR,1),size(IR,2),layers-1); 


RGBstack=zeros(size(RGB,1),size(RGB,2),3,layers);
RGBstack(:,:,:,1)=RGB;
RGBdetail=zeros(size(RGB,1),size(RGB,2),3,layers-1); 

%%%split into detail/base layers
for i=2:layers
    IRblur = imgaussfilt(IR,sigma_s);
    IRstack(:,:,i)=IRblur;
    IRdetail(:,:,i-1)=IRstack(:,:,i)-IRstack(:,:,i-1);

    RGBblur(:,:,1) = imgaussfilt(RGB(:,:,1),sigma_s);
    RGBblur(:,:,2) = imgaussfilt(RGB(:,:,2),sigma_s);
    RGBblur(:,:,3) = imgaussfilt(RGB(:,:,3),sigma_s);
    RGBstack(:,:,:,i)=RGBblur;
    RGBdetail(:,:,:,i-1)=RGBstack(:,:,:,i)-RGBstack(:,:,:,i-1);

    sigma_s=sigma_s*2; %update sigma
end

%%%fusion of base layers
IRbase=IRstack(:,:,end);

RGBbase=RGBstack(:,:,:,end);

V1faster=zeros(size(IRbase,1),size(IRbase,2)); %saliency of IR pixels
V2faster=zeros(size(RGBbase,1),size(RGBbase,2)); %saliency of RGB pixels
IRmean=mean(mean(IRbase));
RGBmean=mean(mean(mean(RGBbase)));


for i=1:size(IRbase,1)
    for j=1:size(IRbase,2)

        V1faster(i,j)=abs(IRbase(i,j)-IRmean);
        V2faster(i,j)=abs((mean(RGBbase(i,j,:))-RGBmean));
    end
end

Wb=0.5+((V1faster-V2faster))./2;

fuzedBase=Wb.*IRbase+(1-Wb).*RGBbase;

Wd=zeros(size(IRdetail,1),size(IRdetail,2),size(IRdetail,3));
for i=1:size(IRdetail,1)
    for j=1:size(IRdetail,2)
        for k=1:size(IRdetail,3)
            
            if(abs(IRdetail(i,j,k))>sum(abs(RGBdetail(i,j,:,k)))/3) %intensity of IR > RGB
                Wd(i,j,k)=1;
            else
                Wd(i,j,k)=0;
            end
            

        end
    end
end

Wd = imgaussfilt(Wd,2);

M=zeros(size(IRdetail,1),size(IRdetail,2),3,size(IRdetail,3));
for layer=1:size(IRdetail,3)
    M(:,:,1,layer)=Wd(:,:,layer).*IRdetail(:,:,layer)+(1-Wd(:,:,layer)).*RGBdetail(:,:,1,layer);
    M(:,:,2,layer)=Wd(:,:,layer).*IRdetail(:,:,layer)+(1-Wd(:,:,layer)).*RGBdetail(:,:,2,layer);
    M(:,:,3,layer)=Wd(:,:,layer).*IRdetail(:,:,layer)+(1-Wd(:,:,layer)).*RGBdetail(:,:,3,layer);
end

maxValFuze=zeros(size(IR,1),size(IR,2),3);
maxValFuze=maxValFuze+fuzedBase;
for layer=1:size(IRdetail,3)
    maxValFuze=maxValFuze+M(:,:,:,layer);
end
Level3_time=toc;



%%% Level 4

sigma_s=2; %smoothing sigma 
layers=5;

IRstack=zeros(size(IR,1),size(IR,2),layers); %fourth dim is detail layer #, j
IRstack(:,:,1)=IR;
IRdetail=zeros(size(IR,1),size(IR,2),layers-1); 


RGBstack=zeros(size(RGB,1),size(RGB,2),3,layers);
RGBstack(:,:,:,1)=RGB;
RGBdetail=zeros(size(RGB,1),size(RGB,2),3,layers-1); 

%%%split into detail/base layers
for i=2:layers
    IRblur = imgaussfilt(IR,sigma_s);
    IRstack(:,:,i)=IRblur;
    IRdetail(:,:,i-1)=IRstack(:,:,i)-IRstack(:,:,i-1);

    RGBblur(:,:,1) = imgaussfilt(RGB(:,:,1),sigma_s);
    RGBblur(:,:,2) = imgaussfilt(RGB(:,:,2),sigma_s);
    RGBblur(:,:,3) = imgaussfilt(RGB(:,:,3),sigma_s);
    RGBstack(:,:,:,i)=RGBblur;
    RGBdetail(:,:,:,i-1)=RGBstack(:,:,:,i)-RGBstack(:,:,:,i-1);

    sigma_s=sigma_s*2; %update sigma
end

%%%fusion of base layers
IRbase=IRstack(:,:,end);

RGBbase=RGBstack(:,:,:,end);

V1=zeros(size(IRbase,1),size(IRbase,2)); %saliency of IR pixels
V2=zeros(size(RGBbase,1),size(RGBbase,2)); %saliency of RGB pixels

%calculate saliency of each pixel

Level4_time1=toc;
tic
for i=1:size(IR,1)
    for j=1:size(IR,2)

        V1(i,j)=sum(sum(abs(IRbase(i,j)-IRbase)))/(size(IR,1)*size(IR,2));

        V2(i,j)=sum(sum(sum(abs(RGBbase(i,j,:)-RGBbase))))/(size(IR,1)*size(IR,2)*size(RGB,3));

    end
end
Level4_time2=toc;
tic
WbVLM=0.5+((V1-V2))./2;

fuzedBaseVLM=WbVLM.*IRbase+(1-WbVLM).*RGBbase;

Wd=zeros(size(IRdetail,1),size(IRdetail,2),size(IRdetail,3));
for i=1:size(IRdetail,1)
    for j=1:size(IRdetail,2)
        for k=1:size(IRdetail,3)
            
            if(abs(IRdetail(i,j,k))>sum(abs(RGBdetail(i,j,:,k)))/3) %intensity of IR > RGB
                Wd(i,j,k)=1;
            else
                Wd(i,j,k)=0;
            end
            

        end
    end
end

Wd = imgaussfilt(Wd,2);

M=zeros(size(IRdetail,1),size(IRdetail,2),3,size(IRdetail,3));
for layer=1:size(IRdetail,3)
    M(:,:,1,layer)=Wd(:,:,layer).*IRdetail(:,:,layer)+(1-Wd(:,:,layer)).*RGBdetail(:,:,1,layer);
    M(:,:,2,layer)=Wd(:,:,layer).*IRdetail(:,:,layer)+(1-Wd(:,:,layer)).*RGBdetail(:,:,2,layer);
    M(:,:,3,layer)=Wd(:,:,layer).*IRdetail(:,:,layer)+(1-Wd(:,:,layer)).*RGBdetail(:,:,3,layer);
end

maxValFuzeVLM=zeros(size(IR,1),size(IR,2),3);
maxValFuzeVLM=maxValFuzeVLM+fuzedBaseVLM;
for layer=1:size(IRdetail,3)
    maxValFuzeVLM=maxValFuzeVLM+M(:,:,:,layer);
end
Level4_time3=toc;
Level4_time=Level4_time1+Level4_time2+Level4_time3;


%%%% Level 5

tic

a=zeros(size(IRbase,1),size(IRbase,1),layers-1);
epsilon=0.00001;
I=eye(size(IRbase,1));
wSize=7;
for k=1:size(a,3)
    d1=imresize(IRdetail(:,:,k),[size(a,1),size(a,2)]);
    for i=wSize+1:size(a,1)-wSize
        for j=wSize+1:size(a,2)-wSize

                if(i==j)
                    asum=sum(sum(d1(i-wSize:i+wSize,j-wSize:j+wSize)));
                    a(i,j,k)=1/abs(asum+epsilon);
                end

        end
    end
end

lambda=0.01;

lamA=lambda*a;
D=zeros(size(M));
propFuzed=zeros(size(maxValFuze));
propFuzed=propFuzed+fuzedBase;

for k=1:layers-1
    RHSred=M(:,:,1,k)+lamA(:,:,k)*RGBdetail(:,:,1,k);
    RHSgreen=M(:,:,2,k)+lamA(:,:,k)*RGBdetail(:,:,2,k);
    RHSblue=M(:,:,3,k)+lamA(:,:,k)*RGBdetail(:,:,3,k);
    
    matrix=I+lamA(:,:,k);
    for i=1:size(matrix,1)
        for j=1:size(matrix,2)
            if(i==j)
               matrix(i,j)=1/matrix(i,j); 
            end
        end
    end
    
    red=matrix*RHSred;
    green=matrix*RHSgreen;
    blue=matrix*RHSblue;
    
    D(:,:,1,k)=red;
    D(:,:,2,k)=green;
    D(:,:,3,k)=blue;
    
    propFuzed=propFuzed+D(:,:,:,k);

    
end
Level5_time1=toc;
Level5_time=Level5_time1+Level4_time;



L1=0.5*(IR+RGB); %level 1 fusion
L2=RGBresult; %level 2 fusion
L3=maxValFuze; %level 3 fusion
L4=maxValFuzeVLM; %level 4 fusion
L5=propFuzed; %level 5 fusion

%%%%%% Data analysis
Comparison=L4; %enter which level you'd like to compare


MSE = mean( (Comparison(:)-L5(:)).^2 );
PSNR = 10*log10(max(max(max(L5)))^2/MSE);

std=0;
mu=mean(mean(mean(Comparison)));
for i=1:size(L1,1)
    for j=1:size(L1,2)
        for k=1:size(L1,3)
            
            std=std+(Comparison(i,j,k)-mu)^2;
            
        end
    end
end

std=std/(size(L1,1)*size(L1,2)*size(L1,3));

